package com.fp.persistence.parmas.soli;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMSANCIONDECOMISO*/
@Entity(name="TarmSancionDecomiso")
@Table(name="TARMSANCIONDECOMISO")
public class TarmSancionDecomiso extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmSancionDecomiso
*/
@EmbeddedId
private TarmSancionDecomisoKey pk;
@Column(name="FECHAINICIO", nullable=true)

/**
* null
*/
private Date fechainicio;

@Column(name="NORESOLUCION", nullable=true)

/**
* Numero de la sancion convertido. SAN-00codigo
*/
private String noresolucion;

@Column(name="CTIPOSANCION", nullable=true)

/**
* Clave primaria de la tabla
*/
private String ctiposancion;

@Column(name="FECHAFINAL", nullable=true)

/**
* Fecha en la que se cumple la sanción
*/
private Date fechafinal;

@Column(name="XPATH", nullable=true)

/**
* xpath del archivo convetido
*/
private String xpath;

@Column(name="PERSONCODE", nullable=true)

/**
* Codigo de persona sancionada
*/
private Integer personcode;

@Column(name="CDOCUMENTO", nullable=true)

/**
* null
*/
private Long cdocumento;

@Column(name="CARMA", nullable=true)

/**
* Codigo de arma
*/
private String carma;

/**Contructor por defecto*/
public TarmSancionDecomiso(){
}
/**Contructor de TarmSancionDecomiso
@param pPk Clave Primaria del entity
*/
public TarmSancionDecomiso(TarmSancionDecomisoKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmSancionDecomiso
*/
public static TarmSancionDecomiso find(EntityManager pEntityManager,TarmSancionDecomisoKey pKey) throws Exception{
    TarmSancionDecomiso obj = pEntityManager.find(TarmSancionDecomiso.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmSancionDecomiso
@return El objeto que referencia a la Clave primaria de TarmSancionDecomiso
*/
public TarmSancionDecomisoKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmSancionDecomiso
@param pPk El objeto que referencia a la nueva Clave primaria de TarmSancionDecomiso
*/
public void setPk(TarmSancionDecomisoKey pPk){
  pk=pPk;
}
/**Obtiene el valor de fechainicio
@return valor de fechainicio*/
public Date getFechainicio(){
  return fechainicio;
}
/**Fija el valor de fechainicio
@param pFechainicio nuevo Valor de fechainicio*/
public void setFechainicio(Date pFechainicio){
  fechainicio=pFechainicio;
}

/**Obtiene el valor de noresolucion
@return valor de noresolucion*/
public String getNoresolucion(){
  return noresolucion;
}
/**Fija el valor de noresolucion
@param pNoresolucion nuevo Valor de noresolucion*/
public void setNoresolucion(String pNoresolucion){
  noresolucion=pNoresolucion;
}

/**Obtiene el valor de ctiposancion
@return valor de ctiposancion*/
public String getCtiposancion(){
  return ctiposancion;
}
/**Fija el valor de ctiposancion
@param pCtiposancion nuevo Valor de ctiposancion*/
public void setCtiposancion(String pCtiposancion){
  ctiposancion=pCtiposancion;
}

/**Obtiene el valor de fechafinal
@return valor de fechafinal*/
public Date getFechafinal(){
  return fechafinal;
}
/**Fija el valor de fechafinal
@param pFechafinal nuevo Valor de fechafinal*/
public void setFechafinal(Date pFechafinal){
  fechafinal=pFechafinal;
}

/**Obtiene el valor de xpath
@return valor de xpath*/
public String getXpath(){
  return xpath;
}
/**Fija el valor de xpath
@param pXpath nuevo Valor de xpath*/
public void setXpath(String pXpath){
  xpath=pXpath;
}

/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de cdocumento
@return valor de cdocumento*/
public Long getCdocumento(){
  return cdocumento;
}
/**Fija el valor de cdocumento
@param pCdocumento nuevo Valor de cdocumento*/
public void setCdocumento(Long pCdocumento){
  cdocumento=pCdocumento;
}

/**Obtiene el valor de carma
@return valor de carma*/
public String getCarma(){
  return carma;
}
/**Fija el valor de carma
@param pCarma nuevo Valor de carma*/
public void setCarma(String pCarma){
  carma=pCarma;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmSancionDecomiso))return false;
    TarmSancionDecomiso that = (TarmSancionDecomiso) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmSancionDecomiso
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmSancionDecomiso
*/
public Object createInstance(){
 TarmSancionDecomiso instance=new TarmSancionDecomiso();	
 instance.setPk(new TarmSancionDecomisoKey());
 return instance;
}
/**Clona la entidad TarmSancionDecomiso
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmSancionDecomiso p=(TarmSancionDecomiso)this.clone();
  p.setPk((TarmSancionDecomisoKey)this.pk.cloneMe());
  return p;
}
}
